<map version="0.9.0">
<!-- To view this file, download free mind mapping software FreeMind from http://freemind.sourceforge.net -->
<node CREATED="1304087954084" ID="ID_1996303597" MODIFIED="1304107180657" TEXT="Comparison of datagram Tor designs">
<node CREATED="1304089363911" ID="ID_153162939" MODIFIED="1304091062666" POSITION="right" TEXT="transport stacks">
<node CREATED="1304089370380" ID="ID_388108438" MODIFIED="1304089376197" TEXT="TCPSpeaker">
<node CREATED="1304089400450" ID="ID_680425047" MODIFIED="1304091067933" TEXT="Dan Levin et al."/>
<node CREATED="1304089416796" ID="ID_1839596446" MODIFIED="1304089426116" TEXT="Code available">
<node CREATED="1304089403740" ID="ID_429696548" MODIFIED="1304089410166" TEXT="BSD-licensed"/>
<node CREATED="1304089431261" ID="ID_417966066" MODIFIED="1304089442693" TEXT="Git"/>
</node>
<node CREATED="1304089618950" ID="ID_1591378814" MODIFIED="1304089629063" TEXT="Designed for Click Modular Router"/>
<node CREATED="1304090298503" ID="ID_967420831" MODIFIED="1304090323733" TEXT="Translator between TCP and a WMN transport"/>
<node CREATED="1304090014004" ID="ID_235507392" MODIFIED="1304090044530" TEXT="Based on 4.4BSD-Lite code annotated by Wright and Stevens">
<node CREATED="1304090864089" ID="ID_1261469483" MODIFIED="1304090869951" TEXT="Basic features (no SACK)"/>
</node>
</node>
<node CREATED="1304091069140" ID="ID_1395034609" MODIFIED="1304091071337" TEXT="CurveCP">
<node CREATED="1304091172973" ID="ID_1833837076" MODIFIED="1304091276835" TEXT="Bi directional datagram cryptography and authenticity">
<node CREATED="1304091399544" ID="ID_589206141" MODIFIED="1304091403341" TEXT="Mandatory"/>
<node CREATED="1304093078164" ID="ID_124252552" MODIFIED="1304093116884" TEXT="Elliptic-curve for setup"/>
<node CREATED="1304093117741" ID="ID_500395405" MODIFIED="1304093122364" TEXT="Symmetric for rest"/>
</node>
<node CREATED="1304091316407" ID="ID_1262220131" MODIFIED="1304091335613" TEXT="Forward secrecy 2 minutes after connection closed">
<node CREATED="1304091355111" ID="ID_421898858" MODIFIED="1304091357767" TEXT="Short term keys"/>
</node>
<node CREATED="1304091278414" ID="ID_1651297485" MODIFIED="1304091283484" TEXT="Stateless (cookie-based)"/>
<node CREATED="1304092229818" ID="ID_334939707" MODIFIED="1304092245222" TEXT="Stream control messages are authenticated">
<node CREATED="1304092421326" ID="ID_341859467" MODIFIED="1304092424068" TEXT="Availability"/>
<node CREATED="1304092413742" ID="ID_1112810089" MODIFIED="1304092419885" TEXT="Stops RST injection"/>
</node>
<node CREATED="1304092662730" ID="ID_1441008563" MODIFIED="1304092670073" TEXT="Randomized retransmission times"/>
<node CREATED="1304092746659" ID="ID_1734388509" MODIFIED="1304092756114" TEXT="Amplification resistance"/>
<node CREATED="1304093146166" ID="ID_971688805" MODIFIED="1304093149125" TEXT="Efficiency">
<node CREATED="1304093152311" ID="ID_610350272" MODIFIED="1304093157821" TEXT="More overhead than TCP"/>
<node CREATED="1304093158607" ID="ID_679923238" MODIFIED="1304093167598" TEXT="Less than SSH/HTTPS"/>
</node>
<node CREATED="1304092811261" ID="ID_1842308607" MODIFIED="1304092815528" TEXT="Needs good clock?"/>
<node CREATED="1304092738500" ID="ID_420056962" MODIFIED="1304092745138" TEXT="No fragmentation"/>
<node CREATED="1304095129344" ID="ID_1930383248" MODIFIED="1304095146049" TEXT="Versatile naming with failover and mobility"/>
</node>
<node CREATED="1304107804374" ID="ID_1554870004" MODIFIED="1304107807009" TEXT="SCTP"/>
</node>
<node CREATED="1304091939284" ID="ID_1184729055" MODIFIED="1304091941290" POSITION="left" TEXT="Layers">
<node CREATED="1304092121448" ID="ID_395771361" MODIFIED="1304092331218" TEXT="Stream transport">
<node CREATED="1304092164745" ID="ID_64933482" MODIFIED="1304092168263" TEXT="Flow control"/>
<node CREATED="1304092168681" ID="ID_1612676686" MODIFIED="1304092171032" TEXT="Reliability"/>
</node>
<node CREATED="1304091942533" ID="ID_1601568954" MODIFIED="1304091946891" TEXT="Transport security">
<node CREATED="1304091949221" ID="ID_1020699600" MODIFIED="1304091952459" TEXT="Currently TLS"/>
<node CREATED="1304091957245" ID="ID_73003985" MODIFIED="1304091974651" TEXT="Provides hop-by-hop confidentiality"/>
<node CREATED="1304091975461" ID="ID_408534541" MODIFIED="1304091982435" TEXT="Hop-by-hop authenticity">
<node CREATED="1304093032290" ID="ID_1026128709" MODIFIED="1304093037001" TEXT="Is this needed?"/>
</node>
</node>
<node CREATED="1304092343796" ID="ID_522032544" MODIFIED="1304092350699" TEXT="Relay">
<node CREATED="1304098919529" ID="ID_152396056" MODIFIED="1304098926411" TEXT="Key exchange"/>
<node CREATED="1304092354829" ID="ID_508861285" MODIFIED="1304092360175" TEXT="Stream de-multiplexing"/>
<node CREATED="1304092360613" ID="ID_1313556203" MODIFIED="1304092365963" TEXT="E2E authenticity">
<node CREATED="1304101448558" ID="ID_659053200" MODIFIED="1304101456586" TEXT="Problem with re-ordering"/>
</node>
</node>
<node CREATED="1304092339236" ID="ID_1371636310" MODIFIED="1304092343099" TEXT="Cell crypto">
<node CREATED="1304092926480" ID="ID_1895674190" MODIFIED="1304092935798" TEXT="Multiple layers"/>
<node CREATED="1304092941104" ID="ID_588155140" MODIFIED="1304092948830" TEXT="No expansion">
<node CREATED="1304092970185" ID="ID_1412929151" MODIFIED="1304092975367" TEXT="No authenticity"/>
<node CREATED="1304092950696" ID="ID_848998090" MODIFIED="1304092962695" TEXT="Padding is an alternative"/>
</node>
<node CREATED="1304101464679" ID="ID_982078346" MODIFIED="1304101471144" TEXT="Problem with re-ordering"/>
</node>
</node>
<node CREATED="1304093202993" ID="ID_971176884" MODIFIED="1304093422085" POSITION="right" TEXT="Congestion management">
<node CREATED="1304093422073" ID="ID_1144330312" MODIFIED="1304093436415" TEXT="Bad Latency">
<node CREATED="1304093210705" ID="ID_104063654" MODIFIED="1304093214296" TEXT="CUBIC">
<node CREATED="1304093215497" ID="ID_1613147464" MODIFIED="1304093217079" TEXT="Linux"/>
<node CREATED="1304094569096" ID="ID_376860985" MODIFIED="1304094579047" TEXT="Somewhat unfriendly to NewReno"/>
</node>
<node CREATED="1304093219193" ID="ID_1627762417" MODIFIED="1304093224984" TEXT="NewReno">
<node CREATED="1304093226881" ID="ID_469434677" MODIFIED="1304093229456" TEXT="FreeBSD"/>
</node>
<node CREATED="1304093231185" ID="ID_803346771" MODIFIED="1304093236944" TEXT="Compound">
<node CREATED="1304093237562" ID="ID_1725826319" MODIFIED="1304093239672" TEXT="Microsoft"/>
</node>
<node CREATED="1304094182720" ID="ID_137720491" MODIFIED="1304094204224" TEXT="Fixes late-comer advantage by synchronizing congestion cycle">
<node CREATED="1304094205752" ID="ID_32888713" MODIFIED="1304094249225" TEXT="Each flow notices maximum congestion at the same moment"/>
</node>
</node>
<node CREATED="1304093444848" ID="ID_1332471467" MODIFIED="1304093447623" TEXT="Good Latency">
<node CREATED="1304093270931" ID="ID_714188122" MODIFIED="1304093771636" TEXT="Chicago">
<node CREATED="1304093274371" ID="ID_961237127" MODIFIED="1304093279882" TEXT="CurveCP"/>
<node CREATED="1304093282323" ID="ID_1612557903" MODIFIED="1304093288531" TEXT="Handles bufferbloat"/>
<node CREATED="1304093658964" ID="ID_1860265110" MODIFIED="1304093684740" TEXT="Periodic rate reduction">
<node CREATED="1304093693509" ID="ID_1706752078" MODIFIED="1304093701357" TEXT="Helps RTT unfairness"/>
</node>
<node CREATED="1304094269282" ID="ID_216200716" MODIFIED="1304094280602" TEXT="Tracks long-term delay statistics"/>
<node CREATED="1304094300426" ID="ID_226735320" MODIFIED="1304094321739" TEXT="Creates short congestion cycles with very low levels of congestion">
<node CREATED="1304094663889" ID="ID_920545038" MODIFIED="1304094677188" TEXT="Notices if other streams not not backing off"/>
</node>
<node CREATED="1304094715554" ID="ID_585093780" MODIFIED="1304094734126" TEXT="Slow-start only continue until delay, not packet loss"/>
<node CREATED="1304094765194" ID="ID_697319518" MODIFIED="1304094780883" TEXT="Differentiates persistent loss with congestion-induced loss"/>
</node>
<node CREATED="1304093456232" ID="ID_1791602590" MODIFIED="1304093460248" TEXT="TCP Vegas">
<node CREATED="1304093841456" ID="ID_1642916349" MODIFIED="1304093851887" TEXT="Measurines minimum RTT"/>
<node CREATED="1304093852624" ID="ID_1678238940" MODIFIED="1304093864367" TEXT="Rate adjusted to min + delta">
<node CREATED="1304093865904" ID="ID_209133498" MODIFIED="1304093880552" TEXT="Delta not so large to indicate congestion"/>
<node CREATED="1304093881816" ID="ID_970034761" MODIFIED="1304093892681" TEXT="Not so mall to empty queue"/>
<node CREATED="1304093906449" ID="ID_107042054" MODIFIED="1304093930936" TEXT="Kept for remainder of flow"/>
</node>
<node CREATED="1304094131119" ID="ID_1721932154" MODIFIED="1304094136142" TEXT="Has late-comer advantage"/>
<node CREATED="1304094420349" ID="ID_1523511855" MODIFIED="1304094427037" TEXT="Not widely deployed">
<node CREATED="1304094428077" ID="ID_1805747402" MODIFIED="1304094435141" TEXT="Probably because it loses out to other schedulers"/>
</node>
</node>
<node CREATED="1304093460904" ID="ID_183771140" MODIFIED="1304093465736" TEXT="LEDBAT">
<node CREATED="1304093521914" ID="ID_1160560154" MODIFIED="1304093525441" TEXT="Low delay"/>
<node CREATED="1304093525914" ID="ID_1701533" MODIFIED="1304093532619" TEXT="Saturate link"/>
<node CREATED="1304093533082" ID="ID_1600275956" MODIFIED="1304093538593" TEXT="Yield to TCP"/>
</node>
</node>
<node CREATED="1304094801331" ID="ID_441625619" MODIFIED="1304094803483" TEXT="?">
<node CREATED="1304094804995" ID="ID_208531561" MODIFIED="1304094808355" TEXT="ECN?"/>
</node>
<node CREATED="1304093608268" ID="ID_1321005448" MODIFIED="1304093624299" TEXT="Problems">
<node CREATED="1304093625500" ID="ID_315096120" MODIFIED="1304093630803" TEXT="RTT unfairness">
<node CREATED="1304093632660" ID="ID_1167915494" MODIFIED="1304093743675" TEXT="Faster RTT will use more rate than slower if rate adjustment depends on RTT"/>
</node>
<node CREATED="1304093937969" ID="ID_458918323" MODIFIED="1304093953105" TEXT="Late-comer advantge">
<node CREATED="1304093964393" ID="ID_287336527" MODIFIED="1304094049393" TEXT="Each TCP Vegas flow increases RTT to (minimum RTT + delta)"/>
<node CREATED="1304093994898" ID="ID_1837050260" MODIFIED="1304094056568" TEXT="Second flow will increase RTT to minimum RTT + 2*delta"/>
<node CREATED="1304094071373" ID="ID_501982430" MODIFIED="1304094116386" TEXT="First flow will back off due in increased RTT until it is essentially zero"/>
</node>
<node CREATED="1304093789903" ID="ID_874724416" MODIFIED="1304093795774" TEXT="Rate management">
<node CREATED="1304093798431" ID="ID_1062057795" MODIFIED="1304093808958" TEXT="Multiplicative decrease on congestion"/>
<node CREATED="1304093809503" ID="ID_1260673199" MODIFIED="1304093818327" TEXT="Additive periodically"/>
</node>
<node CREATED="1304094362724" ID="ID_1581112870" MODIFIED="1304094368299" TEXT="Mixing schedulers">
<node CREATED="1304094369780" ID="ID_149884440" MODIFIED="1304094379852" TEXT="CUBIC is unfriendly to Vegas"/>
</node>
</node>
</node>
<node CREATED="1304097856546" ID="ID_1088145615" MODIFIED="1304097857650" POSITION="left" TEXT="JAP">
<node CREATED="1304098822936" ID="ID_371526807" MODIFIED="1304098828105" TEXT="No forward-secrecy"/>
</node>
<node CREATED="1304097908739" ID="ID_797516775" MODIFIED="1304097913139" POSITION="right" TEXT="Considerations">
<node CREATED="1304104126607" ID="ID_1754174188" MODIFIED="1304104132721" TEXT="Migtation plan"/>
<node CREATED="1304104133407" ID="ID_1705679315" MODIFIED="1304104136193" TEXT="Routing TCP"/>
<node CREATED="1304097915275" ID="ID_1918369911" MODIFIED="1304097923507" TEXT="Triangle-boy"/>
<node CREATED="1304104224584" ID="ID_307070958" MODIFIED="1304104228514" TEXT="Problems">
<node CREATED="1304104230664" ID="ID_570567475" MODIFIED="1304104238890" TEXT="Double congestion control"/>
<node CREATED="1304104239464" ID="ID_246626855" MODIFIED="1304104255476" TEXT="Unecessary delays due to multiplexing"/>
</node>
</node>
<node CREATED="1304099191142" ID="ID_1705257738" MODIFIED="1304099198566" POSITION="left" TEXT="SHALON">
<node CREATED="1304099199893" ID="ID_318879649" MODIFIED="1304099215270" TEXT="TCP hop by hop">
<node CREATED="1304099555835" ID="ID_690755015" MODIFIED="1304099561116" TEXT="No crypto"/>
</node>
<node CREATED="1304099225246" ID="ID_405792291" MODIFIED="1304099294576" TEXT="Nested HTTPS CONNECT E2E"/>
<node CREATED="1304099366048" ID="ID_877404509" MODIFIED="1304099371761" TEXT="No stream multiplexing">
<node CREATED="1304099879330" ID="ID_228285546" MODIFIED="1304099881594" TEXT="TA problem?"/>
</node>
<node CREATED="1304099372176" ID="ID_825929569" MODIFIED="1304099384337" TEXT="No link encryption multiplexing">
<node CREATED="1304099883433" ID="ID_1657320227" MODIFIED="1304099885914" TEXT="TA problem?"/>
</node>
<node CREATED="1304099585356" ID="ID_326768749" MODIFIED="1304099592588" TEXT="Standard libraries"/>
<node CREATED="1304099621804" ID="ID_1833209880" MODIFIED="1304099628351" TEXT="No padding">
<node CREATED="1304100365995" ID="ID_293776859" MODIFIED="1304100414815" TEXT="Intermediate nodes can&apos;t introduce padding"/>
<node CREATED="1304100428708" ID="ID_1090141299" MODIFIED="1304100440037" TEXT="Client limited in what padding can be inserted"/>
</node>
<node CREATED="1304099756175" ID="ID_85383112" MODIFIED="1304099760258" TEXT="Variable packet sizes"/>
<node CREATED="1304099715495" ID="ID_729662409" MODIFIED="1304099730479" TEXT="TLS stack fingerprinting?"/>
<node CREATED="1304099960091" ID="ID_540654673" MODIFIED="1304099962108" TEXT="Faster">
<node CREATED="1304099946651" ID="ID_1028664211" MODIFIED="1304099951109" TEXT="Less decryption"/>
<node CREATED="1304099965819" ID="ID_1483654391" MODIFIED="1304099972838" TEXT="No E2E congestion control"/>
<node CREATED="1304099978299" ID="ID_1523747709" MODIFIED="1304099982460" TEXT="But no multiplexing"/>
<node CREATED="1304100062613" ID="ID_1066842305" MODIFIED="1304100072606" TEXT="Only in lab network">
<node CREATED="1304100187895" ID="ID_1165709199" MODIFIED="1304100191248" TEXT="CPU bound"/>
</node>
</node>
</node>
<node CREATED="1304100586191" ID="ID_169494020" MODIFIED="1304100590736" POSITION="right" TEXT="Liberatore">
<node CREATED="1304100608495" ID="ID_107644724" MODIFIED="1304100612088" TEXT="UDP payload">
<node CREATED="1304100613943" ID="ID_993422442" MODIFIED="1304100620857" TEXT="No congestion management or reliability"/>
</node>
<node CREATED="1304100592335" ID="ID_1033994454" MODIFIED="1304100599408" TEXT="DTLS link-layer crypto"/>
<node CREATED="1304102719307" ID="ID_124649267" MODIFIED="1304103068425" TEXT="Control over TLS/TCP"/>
<node CREATED="1304103298044" ID="ID_228936796" MODIFIED="1304103311205" TEXT="Only RELAY_DATA can go in DTLS"/>
<node CREATED="1304104016445" ID="ID_713518194" MODIFIED="1304104020897" TEXT="Auth only 4 bytes"/>
<node CREATED="1304103511991" ID="ID_1076291370" MODIFIED="1304103528762" TEXT="Sequence number in cell, used for CTR mode">
<node CREATED="1304103679416" ID="ID_748999637" MODIFIED="1304103683219" TEXT="Set by client"/>
<node CREATED="1304103547903" ID="ID_879907985" MODIFIED="1304103551480" TEXT="Could be a nonce"/>
<node CREATED="1304103551919" ID="ID_515169690" MODIFIED="1304103562496" TEXT="Not re-ordered"/>
<node CREATED="1304103566911" ID="ID_1380084025" MODIFIED="1304103575609" TEXT="Does give away re-ordering"/>
</node>
</node>
<node CREATED="1304104783929" ID="ID_79190564" MODIFIED="1304104790917" POSITION="left" TEXT="Kiraly">
<node CREATED="1304104792937" ID="ID_9723701" MODIFIED="1304104798747" TEXT="Nested IPSec tunnels"/>
<node CREATED="1304104851810" ID="ID_1220152230" MODIFIED="1304104859731" TEXT="NAT to hide IP addresses"/>
<node CREATED="1304104896123" ID="ID_1715886468" MODIFIED="1304104900268" TEXT="IKE for control"/>
<node CREATED="1304104905251" ID="ID_1088914598" MODIFIED="1304106019775" TEXT="TCP to destination"/>
<node CREATED="1304104944035" ID="ID_793788221" MODIFIED="1304104948765" TEXT="Standards compliant"/>
<node CREATED="1304106245791" ID="ID_1789205175" MODIFIED="1304106255177" TEXT="No scrubbing, but IPSec and TCP needed"/>
</node>
<node CREATED="1304106039107" ID="ID_1294593103" MODIFIED="1304106041870" POSITION="right" TEXT="Viecco">
<node CREATED="1304106043444" ID="ID_1944305483" MODIFIED="1304106060576" TEXT="TCP/SOCKS to exit"/>
<node CREATED="1304106061076" ID="ID_1331489235" MODIFIED="1304106064478" TEXT="Protocol scrubbing"/>
<node CREATED="1304106180270" ID="ID_831356979" MODIFIED="1304106192569" TEXT="Custom Transport encyrptioon">
<node CREATED="1304106194038" ID="ID_1724588563" MODIFIED="1304106198664" TEXT="Plan to move to DTLS"/>
</node>
<node CREATED="1304106233583" ID="ID_1784279678" MODIFIED="1304106239593" TEXT="Scrubbing of TCP header"/>
</node>
<node CREATED="1304106756966" ID="ID_642680767" MODIFIED="1304106759137" POSITION="left" TEXT="Cebolla">
<node CREATED="1304106760390" ID="ID_1045122449" MODIFIED="1304106764145" TEXT="Routes IP"/>
<node CREATED="1304106764583" ID="ID_1496019501" MODIFIED="1304106770201" TEXT="Tunelled over UDP"/>
<node CREATED="1304106770743" ID="ID_1124203747" MODIFIED="1304106774019" TEXT="Nested encryption"/>
</node>
<node CREATED="1304107181901" ID="ID_45616069" MODIFIED="1304107186506" POSITION="right" TEXT="Freedom">
<node CREATED="1304107186837" ID="ID_1266389197" MODIFIED="1304107220096" TEXT="Scrubbing at stream"/>
<node CREATED="1304107207725" ID="ID_1439067511" MODIFIED="1304107235146" TEXT="Scrubbing at IP packets/encryption"/>
<node CREATED="1304107294207" ID="ID_1626173932" MODIFIED="1304107298306" TEXT="TCP E2E"/>
<node CREATED="1304107362400" ID="ID_495319106" MODIFIED="1304107366588" TEXT="Control over TCP"/>
</node>
</node>
</map>
